



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>十依据一个有用的算法来找到最小(最大)的k的数量-线性搜索算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">十依据一个有用的算法来找到最小(最大)的k的数量-线性搜索算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 05:47:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>例如：进入1。2。3，4，5，6。7。8此8数字，最小的4图的1，2，3，4。</p>
<p>思路1：最easy想到的方法：先对这个序列从小到大排序。然后输出前面的最小的k个数就可以。假设选择高速排序法来进行排序，则时间复杂度：O（n*logn）</p>
<p>注：针对不同问题我们应该给出不同的思路。假设在应用中这个问题的规模不大。或者求解前k个元素的频率非常高，或者k是不固定的。</p>
<p>那么我们花费较多的时间对问题排序。在以后是使用中能够线性时间找到问题的解，整体来说，那么思路一的解法是最优的。</p>
<p>思路2：在思路1的基础上更进一步想想，题目并没有要求要查找的k个数。甚至后n-k个数是有序的。既然如此。咱们又何必对全部的n个数都进行排序列?如此。我们能想打的一个方法是：遍历n个数，先把最先遍历到得k个数存入大小为k的数组之中，对这k个数。利用选择或交换排序，找到k个数中的最大数kmax（kmax设为k个元素的数组中最大元素），用时O（k）（你应该知道，插入或选择排序查找操作须要O（k）的时间），后再继续遍历后n-k个数，x与kmax比較：假设x&lt;kmax，则x取代kmax，并再次又一次找出k个元素的数组中最大元素kmax‘；假设x&gt;kmax，则不更新数组。这样。每次更新或不更新数组的所用的时间为O（k）或O（0），整趟下来，总的时间复杂度平均下来为：n*O（k）=O（n*k）</p>
<p>思路3：与思路2方法类&#20284;，仅仅是用容量为k的最大堆代替思路2中数组的作用（从数组中找最大数须要O(k)次查找，而从更新一个堆使之成为最大堆仅仅须要O(logk)次操作）。详细做法例如以下：用容量为k的最大堆存储最先遍历到的k个数，并如果它们即是最小的k个数。建堆费时O（k）后。有k1&lt;k2&lt;…&lt;kmax（kmax设为大顶堆中最大元素）。继续遍历数列，每次遍历一个元素x。与堆顶元素比較，x&lt;kmax，更新堆（用时logk），否则不更新堆。</p>
<p>这样下来，总费时O（k&#043;（n-k）*logk）=O（n*logk）。</p>
<p>思路4：按编程之美中给出的描写叙述，类&#20284;高速排序的划分方法，N个数存储在数组S中，再从数组中随机选取一个数X（随机选取枢纽元。可做到线性期望时间O（N）的复杂度）。把数组划分为Sa和Sb俩部分，Sa&lt;=X&lt;=Sb，假设要查找的k个元素小于Sa的元素个数，则返回Sa中较小的k个元素，否则返回Sa中全部元素&#043;Sb中小的k-|Sa|个元素。像上述过程一样，这个运用类&#20284;高速排序的partition的高速选择SELECT算法寻找最小的k个元素，在最坏情况下亦能做到O（N）的复杂度。</p>
<p>oh。太酷了，有没有！</p>
<p>思路5：仍然用到数据结构：堆。详细做法为：针对整个数组序列建最小堆。建堆所用时间为O（n），然后取堆中的前k个数。总的时间复杂度即为：O（n&#043;k*logn）。</p>
<p>思路6：与上述思路5类&#20284;，不同的是在对元素数组原地建最小堆O(n)后，然后提取K次。<strong>可是每次提取时。换到顶部的元素仅仅须要下移顶多k次就足够了</strong>，下移次数逐次降低（<em>而上述思路5每次提取都须要logn，所以提取k次，思路5须要k*logn。而本思路仅仅须要K^2</em>）。此种方法的复杂度为O(n&#043;k^2)。</p>
<p>此方法可能不太直观，一个更直观的理解是：每次取出堆顶元素后，最小堆的性质被破坏了，我们须要调整最小堆使之满足最小堆的性质。</p>
<p>因为我们仅仅须要求取前k个数，我们无需将整个堆都完整的调整好。仅仅需保证堆的最上面k个数是最小的就能够，即第一趟调整保持第0层到第k层是最小堆，第二趟调整保持第0层到第k-1层是最小堆…，依次类推。</p>
<p>几个简单的提取前k个元素，居然能够有这么多的思路来实现，复杂度逐渐减少。感觉是多么酷的一件事情啊。</p>
<p>以下给出思路三和思路四的參考代码（这些代码都凝结了高速排序和堆排序的思想，所以说之前的算法有用，主要是思想）：</p>
<p>思路三：</p>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#define PARENT(i) (i)/2<br />
#define LEFT(i) 2*(i)+1<br />
#define RIGHT(i) 2*(i+1)

void swap(int *a,int *b)<br />
{<br />
    *a=*a^*b;<br />
    *b=*a^*b;<br />
    *a=*a^*b;<br />
}<br />
void max_heapify(int *arr,int index,int len)//建立大顶堆的过程。求前k个最小，要健最大堆<br />
{<br />
    int l=LEFT(index);//全部操作相似于堆排序<br />
    int r=RIGHT(index);<br />
    int largest;<br />
    if(l&lt;len &amp;&amp; arr[l]&gt;arr[index])<br />
        largest=l;<br />
    else<br />
        largest=index;<br />
    if(r&lt;len &amp;&amp; arr[r]&gt;arr[largest])<br />
        largest=r;<br />
    if(largest != index){//将最大元素提升。并递归<br />
        swap(&amp;arr[largest],&amp;arr[index]);<br />
        max_heapify(arr,largest,len);//递归<br />
    }<br />
}

void build_maxheap(int *arr,int len)//開始建立大顶堆是必须的<br />
{<br />
    int i;<br />
    if(arr==NULL || len&lt;=1)<br />
        return;<br />
    for(i=len/2+1;i&gt;=0;--i)<br />
        max_heapify(arr,i,len);<br />
}

void k_min(int *arr,int len,int k)<br />
{<br />
    int i;<br />
    build_maxheap(arr,k);<br />
    for (i = k;i &lt; len;i++)<br />
    {<br />
        if (arr[i] &lt; arr[0])//就是这一个地方跟堆排序不一样，这里仅仅是交换比堆顶大的元素。<br />
        {<br />
            arr[0] = arr[i];<br />
            max_heapify(arr,0,k);<br />
        }<br />
    }<br />
}<br />
/*<br />
void heap_sort(int *arr,int len)//这是堆排序的主函数<br />
{<br />
    int i;<br />
    if(arr==NULL || len&lt;=1)<br />
        return;<br />
    build_maxheap(arr,len);

    for(i=len-1;i&gt;=1;--i){<br />
        swap(&amp;arr[0],&amp;arr[i]);<br />
        max_heapify(arr,0,--len);<br />
    }<br />
}<br />
*/

int main()<br />
{<br />
    int arr[10]={91,8,6,82,15,18,7,46,29,12};<br />
    int i;<br />
    k_min(arr,10,4);<br />
    for(i=0;i&lt;10;++i)//仅仅须要输出前k个元素就可以。<br />
        printf(&quot;%d &quot;,arr[i]);<br />
    system(&quot;pause&quot;);<br />
}</pre>
<p>思路四的实现：</p>
<pre class="prettyprint linenums">Kbig(S, k):<br />
     if(k &lt;= 0):<br />
          return []     // 返回空数组<br />
     if(length S &lt;= k):<br />
          return S<br />
     (Sa, Sb) = Partition(S)<br />
     return Kbig(Sa, k).Append(Kbig(Sb, k – length Sa)  

Partition(S):<br />
     Sa = []            // 初始化为空数组<br />
     Sb = []        // 初始化为空数组<br />
     Swap(s[1], S[Random()%length S])   // 随机选择一个数作为分组标准，以<br />
                        // 避免特殊数据下的算法退化，也可<br />
                       // 以通过对整个数据进行洗牌预处理<br />
                        // 实现这个目的<br />
     p = S[1]<br />
     for i in [2: length S]:<br />
         S[i] &gt; p ? Sa.Append(S[i]) : Sb.Append(S[i])<br />
                            // 将p增加较小的组。能够避免分组失败。也使分组<br />
                           // 更均匀，提高效率<br />
     length Sa &lt; length Sb ? Sa.Append(p) : Sb.Append(p)<br />
     return (Sa, Sb)  </pre>
<p>以下是代码实现：</p>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
    #include &lt;stdlib.h&gt;<br />
     void swap(int *a,int *b)<br />
    {   *a=*a^*b;<br />
        *b=*a^*b;<br />
        *a=*a^*b;<br />
    }<br />
    /*<br />
    为了简单起见，这里仅仅是单纯的选取第一个元素作为枢纽元素。这样选取枢纽，就难避免使得算法easy退化。

*/<br />
    int k_big(int arr[],int low,int high,int k)<br />
    {<br />
        int pivot  = arr[low];//pivot的选择能够更优<br />
        int high_tmp = high;<br />
        int low_tmp = low;<br />
        while(low &lt; high){<br />
            //从右向左查找，直到找到第一个小于枢纽元素为止<br />
            while (low &lt; high &amp;&amp; arr[high] &gt;= pivot)<br />
            {<br />
                --high;<br />
            }<br />
            arr[low] = arr[high];<br />
            //从左向右查找，直到找到第一个大于枢纽元素为止<br />
            while (low &lt; high &amp;&amp; arr[low] &lt;= pivot)<br />
            {<br />
                ++low;<br />
            }<br />
            arr[high] = arr[low];<br />
        }<br />
        arr[low] = pivot;//这里low == high

        if (low == k - 1)//正好取到了第k个值<br />
        {<br />
            return arr[low];<br />
        }else if(low &gt; k - 1)//前k个值在low前面的子数组中<br />
        {<br />
            return k_big(arr,low_tmp,low-1,k);<br />
        }else//前low个数值已经是前k个数值，后k-low个在后半部分中<br />
        {<br />
            return k_big(arr,low+1,high_tmp,k);<br />
        }<br />
    }<br />
    int main()<br />
    {<br />
        int arr[10]={-91,0,6,82,15,18,7,46,-29,12};<br />
        int i;<br />
        k_big(arr,0,9,4);<br />
        for(i=0;i&lt;10;++i)<br />
            printf(&quot;%d &quot;,arr[i]);<br />
        system(&quot;pause&quot;);<br />
    }</pre>
<p>以下是《算法设计与分析》书中给出的一种思路，源代码例如以下：</p>
<pre class="prettyprint linenums">//QuickSelect 将第k小的元素放在 a[k-1]<br />
void QuickSelect( int a[], int k, int left, int right )<br />
{<br />
    int i, j;<br />
    int pivot;

    if( left + cutoff &lt;= right )<br />
    {<br />
        pivot = median3( a, left, right );<br />
        //取三数中值作为枢纽元。能够非常大程度上避免最坏情况<br />
        i = left; j = right - 1;<br />
        for( ; ; )<br />
        {<br />
            while( a[ ++i ] &lt; pivot ){ }<br />
            while( a[ --j ] &gt; pivot ){ }<br />
            if( i &lt; j )<br />
                swap( &amp;a[ i ], &amp;a[ j ] );<br />
            else<br />
                break;<br />
        }<br />
        //重置枢纽元<br />
        swap( &amp;a[ i ], &amp;a[ right - 1 ] );  

        if( k &lt;= i )<br />
            QuickSelect( a, k, left, i - 1 );<br />
        else if( k &gt; i + 1 )<br />
            QuickSelect( a, k, i + 1, right );<br />
    }<br />
    else<br />
        InsertSort( a + left, right - left + 1 );<br />
}</pre>
<p>这个高速选择SELECT算法。类&#20284;高速排序的划分方法。N个数存储在数组S中，再从数组中选取“中位数的中位数”作为枢纽元X，把数组划分为Sa和Sb俩部分，Sa&lt;=X&lt;=Sb，假设要查找的k个元素小于Sa的元素个数，则返回Sa中较小的k个元素。否则返回Sa中全部元素&#043;Sb中小的k-|Sa|个元素。这样的解法在平均情况下能做到&nbsp;<code>&nbsp;O（N）&nbsp;</code>&nbsp;的复杂度。</p>
<p>以下是算法导论中给出的一种方法：</p>
<p>《算法导论》介绍了一个随机选取主元的选择算法RANDOMIZED-SELECT。它每次都是随机选取数列中的一个元素作为主元，在&nbsp;<code>&nbsp;O（n）</code>&nbsp;的时间内找到第k小的元素，然后遍历输出前面的k个小的元素。平均时间复杂度：&nbsp;<code>&nbsp;O（n&#043;k）=O（n）&nbsp;</code>&nbsp;（当k比較小时）。</p>
<p>我们知道，高速排序是以固定的第一个或最后一个元素作为主元，每次递归划分都是不均等的。最后的平均时间复杂度为：&nbsp;<code>&nbsp;O（n*logn）</code>&nbsp;。而RANDOMIZED-SELECT与普通的高速排序不同，它每次递归都是随机选择序列，从第一个到最后一个元素中任一一个作为主元。</p>
<p>以下是RANDOMIZED-SELECT(A, p, r)完整伪码：</p>
<pre class="prettyprint linenums">PARTITION(A, p, r)         //partition过程 p为第一个数，r为最后一个数<br />
  x ← A[r]               //以最后一个元素作为主元<br />
  i ← p - 1<br />
  for j ← p to r - 1<br />
       do if A[j] ≤ x<br />
             then i ← i + 1<br />
                  exchange A[i] &lt;-&gt; A[j]<br />
  exchange A[i + 1] &lt;-&gt; A[r]<br />
  return i + 1

RANDOMIZED-PARTITION(A, p, r)      //随机快排的partition过程<br />
  i ← RANDOM(p, r)                                 //i  随机取p到r中个一个值<br />
  exchange A[r] &lt;-&gt; A[i]                         //以随机的 i作为主元<br />
  return PARTITION(A, p, r)            //调用上述原来的partition过程

RANDOMIZED-SELECT(A, p, r, i)       //以线性时间做选择。目的是返回数组A[p..r]中的第i 小的元素<br />
  if p = r          //p=r。序列中仅仅有一个元素<br />
      then return A[p]<br />
  q ← RANDOMIZED-PARTITION(A, p, r)   //随机选取的元素q作为主元<br />
  k ← q - p + 1             //k表示子数组 A[p…q]内的元素个数，处于划分低区的元素个数加上一个主元元素<br />
  if i == k                        //检查要查找的i 等于子数组中A[p....q]中的元素个数k<br />
      then return A[q]        //则直接返回A[q]<br />
  else if i &lt; k<br />
      then return RANDOMIZED-SELECT(A, p, q - 1, i)<br />
          //得到的k 大于要查找的i 的大小，则递归到低区间A[p。q-1]中去查找<br />
  else return RANDOMIZED-SELECT(A, q + 1, r, i - k)<br />
          //得到的k 小于要查找的i 的大小。则递归到高区间A[q+1，r]中去查找。  </pre>
<p>也就是线性查找算法：</p>
<p><strong>算法步骤：</strong></p>
<p>1.&nbsp;将n个元素每5个一组，分成n/5(上界)组。</p>
<p>2.&nbsp;取出每一组的中位数，随意排序方法，比方插入排序。</p>
<p>3.&nbsp;递归的调用selection算法查找上一步中全部中位数的中位数，设为x，偶数个中位数的情况下设定为选取中间小的一个。</p>
<p>4.&nbsp;用x来切割数组。设小于等于x的个数为k。大于x的个数即为n-k。</p>
<p>5.&nbsp;若i==k，返回x。若i&lt;k，在小于x的元素中递归查找第i小的元素。若i&gt;k，在大于x的元素中递归查找第i-k小的元素。</p>
<p>终止条件：n=1时，返回的即是i小元素。</p>

<div>
<p>版权声明：本文博客原创文章，博客，未经同意，不得转载。</p></p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2xvx97.html">java中易错点（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5y5jq.html">ArcGIS发布服务时缓存切片设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwpezy8.html">PHP 设置代码执行时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/390x6mj9.html">解决Hibernate向MySQL数据库插入中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx35w0q.html">Linux&lowbar;08------Linux的系统管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jmdr9.html">wcf 获取客户端 IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1nn339.html">&lbrack;转&rsqb;Struts标签库详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydkznjq.html">mobile js</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj1mg49.html">xcode - 触摸移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v5jjq.html">&lpar;step 8&period;2&period;8&rpar;hdu 1079&lpar;Calendar Game&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rezzq.html">Java Web实现IOC控制反转之依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zjl6g9.html">jQuery 插件 Magnify 开发简介（仿 Windows 照片查看器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk707d8.html">&lbrack;Swift&rsqb;LeetCode62&period; 不同路径 &vert; Unique Paths</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljy4119.html">【原创】大叔问题定位分享（11）Spark中对大表子查询加limit为什么会报Broadcast超时错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpm2zjq.html">Java并发编程的4个同步辅助类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2n4ppq.html">更改系统盘符后DFS无法复制故障处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwp1479.html">java 坑总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q255xe3q.html">python基础自学 第三天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy6jvmq.html">1&period;2 VMware安装过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjdnr28.html">搭建项目Maven&plus;springMVC&plus;hibernate时，JUnit測试出现报ClassNotFoundException错误的解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy11dwdq.html">黄聪：Microsoft Enterprise Library 5&period;0 系列教程&lpar;二&rpar; Cryptography Application Block &lpar;高级&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpp1mj9.html">Android涉及到的设计模式&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljjm7k9.html">IT痴汉的工作现状13-吓唬电话</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljj1v19.html">新书《iOS8 Swift编程指南》货架</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ppmmn8.html">排列组合相关算法 python</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yyj4z8.html">产品经理（五岁以下儿童）myVegas Slots排名上升的秘密</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kk5e49.html">aspx向silverlight传值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjj5dx8.html">oralce 获取自定义主键编码，有并发问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkkeg08.html">安装nodejs搭建ghost个人博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddx1k9.html">【Stackoverflow好问题】将InputStream转换为String</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
